#include "dll.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#INCLUDE "FILEIO.CH"
#INCLUDE "SET.CH"

#INCLUDE "SHFILE.CH"

/*

   SHFile Class testprogram, see below for Class documentation

   The complete class is freeware.

*/

PROC MAIN
LOCAL cSHFO, nH

   oSHFO := ShFile():New():Create()

   ? "Creating ShFile1.TXT"

   nH := FCREATE( "ShFile1.TXT" )
   FWrite( nH, "James Bond's BMW", 16 )
   FClose( nH )

   ? "Creating ShFile2.TXT"

   nH := FCREATE( "ShFile2.TXT" )
   FWrite( nH, "James Bond's new BMW", 16 )
   FClose( nH )

   ? "Creating a Directory"
   oSHFO:CreateDir( "SUB1" )

   nChoose := 1

   DO WHILE nChoose # 0

      @ 5,5 PROMPT " Delete files                        "
      @ 6,5 PROMPT " Copy file to single destination     "
      @ 7,5 PROMPT " Copy multiple files to multidest.   "
      @ 8,5 PROMPT " Rename file                         "
      @ 9,5 PROMPT " Rename multiple files               "

      MENU TO nChoose

      DO CASE
         CASE nChoose = 1
            oSHFO:Delete( { "ShFile1.TXT", "ShFile2.TXT" } )

         CASE nChoose = 2
            oSHFO:Copy( "ShFile1.TXT", "C:\WINDOWS\TEMP" )

         CASE nChoose = 3
            oSHFO:Copy( { "ShFile1.TXT", "ShFile2.TXT" }, { "C:\WINDOWS\TEMP\ShFile1.txt", "C:\TEMP\ShFile2.txt" } )

         CASE nChoose = 4
            oSHFO:Rename( "ShFile1.TXT", "NewShFile1.TXT" )

         CASE nChoose = 5
            oSHFO:Rename( "*.TXT", "*.TX2" )

         OTHERWISE
            nChoose = 0

      EndCASE

   ENDDO
   @ 11,5 SAY "Press any key to continue"
   oSHFO:RemoveDir( "SUB1" )

   INKEY(0)

RETURN

/*

   SHFile-Class

   What it does :

      Provides a wrapper for the SHFileOperation-API function

   Which methods are avalaible for the "public" :

      Well, they do just what their names are telling !
      For further explanations see the header of each method

      Copy
      Move
      Rename
      Delete

   SHFile needs the BAP-Library from Alaska to work correctly, so
   be sure that you provide the BAP.DLL with your programs.

   Revision history :

      Current Version 0.7

      13.02.2000  some small fixes in the CheckPath method.
                  Added CreateDir and RemoveDir methods

      07.02.2000  Initial Version, delete is basically working
                  copy is working, see notes in method header !

*/

CLASS ShFile FROM xbpStatic

   VAR aOpStruct, cFileOpStruct
   VAR cSrc, cDest, lMultiDest
   VAR nOperation, nDllHandle
   VAR nFlags, hWnd, lConfirm

   METHOD PreparePath, CheckPath, BuildStruct, ExecCall

   EXPORTED:

   METHOD Init, Create, Destroy
   METHOD Copy, Move, Rename, Delete
   METHOD CreateDir, RemoveDir

ENDCLASS

/*-----------------------------------------------------------------------------

METHOD ShFile:Init

*/
METHOD ShFile:Init

   ::xbpStatic:Init()
   ::type := XBPSTATIC_TYPE_TEXT

RETURN self

/*-----------------------------------------------------------------------------

METHOD ShFile:Create( oPar, oOwn, aPos, aSize, aPresPar )

*/
METHOD ShFile:Create( oPar, oOwn, aPos, aSize, aPresPar )

   // Create invisible Object
   ::xbpStatic:Create( oPar, oOwn, aPos, aSize, aPresPar, .F. )
   ::hWnd := ::GetHwnd()
   ::lMultiDest := .F.

RETURN self

/*-----------------------------------------------------------------------------

METHOD ShFile:Destroy

*/
METHOD ShFile:Destroy

   ::aOpStruct :=  ::cFileOpStruct := ::cSrc := cDest := lMultiDest := NIL
   ::nOperation := ::nDllHandle := ::nFlags := hWnd := lConfirm := NIL
   ::xbpStatic:Destroy()

RETURN self


/*-----------------------------------------------------------------------------

METHOD ShFile:Copy( xSrc, xDest, lConfirm )

   xSrc and xDest can be single filenames
   or arrays containing several files

   If xDest is an array, the number of elements must be identical
   to the number in xSrc. Each element in xDest must contain the full
   destination filename including the path.

*/
METHOD ShFile:Copy( xSrc, xDest, lConfirm )

   DEFAULT lConfirm TO .F.

   ::cSrc       := ::PreparePath( xSrc )
   ::cDest      := ::PreparePath( xDest )
   ::nOperation := FO_COPY
   If VALTYPE( xDest ) = "A"
      If LEN( xDest ) > 1
         ::lMultiDest := .T.
      EndIF
   EndIF
   ::lConfirm   := lConfirm
   ::BuildStruct()
   ::ExecCall()

RETURN NIL

/*-----------------------------------------------------------------------------

METHOD ShFile:Move( xSrc, xDest, lConfirm )

   Move files from one location to another, just pass .T. in the third
   parameter if you need a "do you really want to do this?" window.

   xSrc can be a single filename or an array containing several files

*/
METHOD ShFile:Move( xSrc, xDest, lConfirm )

   DEFAULT lConfirm TO .F.

   ::cSrc       := ::PreparePath( xSrc )
   ::cDest      := ::PreparePath( xDest )
   ::nOperation := FO_MOVE
   If VALTYPE( xDest ) = "A"
      If LEN( xDest ) > 1
         ::lMultiDest := .T.
      EndIF
   EndIF
   ::lConfirm   := lConfirm
   ::BuildStruct()
   ::ExecCall()

RETURN NIL

/*-----------------------------------------------------------------------------

METHOD ShFile:Rename(xSrc, xDest, lConfirm )

   Rename files, just pass .T. in the third parameter if you
   need a "do you really want to do this?" window.

   xSrc and xDest can be single filenames
   or arrays containing several files

   If xDest is an array, the number of elements must be identical
   to the number in xSrc. Each element in xDest must contain the full
   destination filename including the path.


*/
METHOD ShFile:Rename(xSrc, xDest, lConfirm )

   DEFAULT lConfirm TO .F.

   ::cSrc       := ::PreparePath( xSrc )
   ::cDest      := ::PreparePath( xDest )
   ::nOperation := FO_RENAME
   If VALTYPE( xDest ) = "A"
      If LEN( xDest ) > 1
         ::lMultiDest := .T.
      EndIF
   EndIF
   ::lConfirm   := lConfirm
   ::BuildStruct()
   ::ExecCall()

RETURN NIL

/*-----------------------------------------------------------------------------

METHOD ShFile:Delete( cFile, lConfirm )

*/
METHOD ShFile:Delete( xFile, lConfirm )

   DEFAULT lConfirm TO .F.

   ::cSrc       := ::PreparePath( xFile )
   ::cDest      := "" + CHR(0)
   ::nOperation := FO_DELETE
   ::lConfirm   := lConfirm
   ::BuildStruct()
   ::ExecCall()

RETURN NIL

/*-----------------------------------------------------------------------------

METHOD ShFile:CreateDir( cDir )

   Create a new directory, cDir can be a complete or relative path but
   you can not create a complete path ( C:\SUB1\SUB2 ) in one step, you
   will have to use

   oSHFile:CreateDir( "C:\SUB1" )
   oSHFile:CreateDir( "C:\SUB1\SUB2" )

*/
METHOD ShFile:CreateDir( cDir )
   LOCAL lRet := .F.

   ::nDllHandle :=DllLoad("KERNEL32.DLL")
   IF ::nDllHandle != 0
      lRet := ( DllCall(::nDllHandle,DLL_STDCALL,"CreateDirectoryA", cDir, 0 ) # 0 )
      DllUnload(::nDllHandle)
   ENDIF

RETURN lRet

/*-----------------------------------------------------------------------------

METHOD ShFile:RemoveDir( cDir )

   Remove a directory, cDir can be a complete or relative path

*/
METHOD ShFile:RemoveDir( cDir )
   LOCAL lRet := .F.

   ::nDllHandle :=DllLoad("KERNEL32.DLL")
   IF ::nDllHandle != 0
      lRet := ( DllCall(::nDllHandle,DLL_STDCALL,"RemoveDirectoryA", cDir, 0 ) # 0 )
      DllUnload(::nDllHandle)
   ENDIF

RETURN lRet


/*-----------------------------------------------------------------------------

METHOD ShFile:PreparePath( xSrc )

   Internal helper method to make the filenames what they are supposed to be,
   also provides support for managing a file-list via an array.

*/
METHOD ShFile:PreparePath( xSrc, lCheckPath )
LOCAL cRet, nI

   DEFAULT lCheckPath TO .T.

   If VALTYPE( xSrc ) = "C"
      xSrc := ::CheckPath( xSrc )
      cRet := TRIM(xSrc) + CHR(0)
   EndIF

   If VALTYPE( xSrc ) = "A"

      cRet := ""

      If lCheckPath
         For nI := 1 TO LEN( xSrc )
            xSrc[nI] := ::CheckPath( xSrc[nI] )
         Next
      EndIF

      AEVAL( xSrc, { | cEl | cRet += TRIM(cEl) + CHR(0) } )

      cRet += CHR(0)

   EndIF

RETURN cRet

/*-----------------------------------------------------------------------------

METHOD ShFile:CheckPath( xSrc )

   Internal helper method to check if a fully qualified path is provided

   Valid paths are :

      C:\File
      \\Computer\Share\File

   Invalid paths are :

      \File
      .\File
      File


*/
METHOD ShFile:CheckPath( xSrc )
LOCAL cRet := xSrc
LOCAL lExact := SET( _SET_EXACT, .F. )

   DO CASE
      CASE xSrc = "\\"                           // UNC-Path supplied, nothing to do

      CASE UPPER(SUBSTR( xSrc, 1, 1 )) $ "ABCDEFGHIJKLMNOPQRSTUVWXYZ" .AND.;
           SUBSTR( xSrc, 2, 2 ) = ":\"           // "C:\"-Type

      CASE xSrc = ".\"

         cRet := CURDRIVE() + ":\" + CURDIR(CURDRIVE()) + SUBSTR(xSrc,2)

      CASE xSrc = "\"

         cRet := CURDRIVE() + ":" + xSrc

      OTHERWISE

         cRet := CURDRIVE() + ":\" + CURDIR(CURDRIVE()) + xSrc

   ENDCASE

   SET( _SET_EXACT, lExact )

RETURN cRet

/*-----------------------------------------------------------------------------

  Create structure string needed for the SHFileOperation call in :ExecCall

*/
METHOD ShFile:BuildStruct
   LOCAL lRet
   LOCAL fAborted  := 0
   LOCAL hNameMaps := 0
   LOCAL cProgress := ""

   IF ::lConfirm
      ::nFlags := FOF_ALLOWUNDO + FOF_RENAMEONCOLLISION
   ELSE
      ::nFlags := FOF_ALLOWUNDO + FOF_SILENT + FOF_NOCONFIRMATION + FOF_RENAMEONCOLLISION
   ENDIF

   If ::lMultiDest
      ::nFlags += FOF_MULTIDESTFILES
   EndIF

   ::lMultiDest := .F.

   ::aOpStruct := BaInit(8)

   lRet  := BaStruct(::aOpStruct,::hWnd)       // Not used
   lRet  := BaStruct(::aOpStruct,::nOperation) // Sub-function number
   lRet  := BaStruct(::aOpStruct,@::cSrc)      // Name of file to delete
   lRet  := BaStruct(::aOpStruct,@::cDest)     // Not used
   lRet  := BaStruct(::aOpStruct,::nFlags)     // How to do it
   lRet  := BaStruct(::aOpStruct,fAborted)     // Not used
   lRet  := BaStruct(::aOpStruct,hNameMaps)    // Not used
   lRet  := BaStruct(::aOpStruct,@cProgress)        // Not used

   ::cFileOpStruct := BaAccess(::aOpStruct)

RETURN NIL


/*-----------------------------------------------------------------------------

METHOD ShFile:ExecCall

   Does the actual DLL-calling

*/
METHOD ShFile:ExecCall

   ::nDllHandle :=DllLoad("SHELL32.DLL")
   IF ::nDllHandle != 0
      DllCall(::nDllHandle,DLL_STDCALL,"SHFileOperationA",@::cFileOpStruct)
      DllUnload(::nDllHandle)
   ENDIF

   // Clean up BAP
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   BaExtract(::aOpStruct)
   ::aOpStruct := NIL

RETURN NIL